 %------------------------------------------------------------------
 %    HBM    
 %    
 %    the linear operator L
 
function [L] = L(obj,U)

  H=obj.H;                            % number of harmonics
  Neq=obj.Neq;                        % number of equations

  indc=[Neq+1  :2*Neq:Neq*(2*H-1)+1];     % index of  uic 
  inds=[2*Neq+1:2*Neq:Neq*(2*H)+1  ];     % index of  uis 

  L=zeros(Neq*(2*H+1)+1,1);
% 
%  L depends on  pL0  (see annexe 1)
%  ---------------------------------
     L(1:Neq)=pL0(U(1:Neq),obj);
  for i=1:H    
     L(Neq+2*(i-1)*Neq+1:2*Neq+2*(i-1)*Neq)  =pL0(U(indc(i):indc(i)+Neq-1),obj);
     L(2*Neq+2*(i-1)*Neq+1:3*Neq+2*(i-1)*Neq)=pL0(U(inds(i):inds(i)+Neq-1),obj);
  end
% Phase equation
     L(Neq*(2*H+1)+1)=U(2*Neq+1) ;
end

 %------------------------------------------------------------------
 %    
 %    clarinette model
 
function [pL0] = pL0(U,obj)

  Neq  =obj.Neq;                       
  N    =obj.N;
  zeta =obj.zeta;
  wr   =obj.wr;
  qr   =obj.qr;
  c    =obj.c;
  alpha=obj.alpha;
  w    =obj.w;

  pL0=zeros(Neq,1);
  
  pL0(1)= U(2);      
  pL0(2)= wr^2*sum(U(3:2+N)) - qr*wr*U(2) -wr^2*U(1);
  pL0(3:2+N)= U(N+3:2*N+2);
  pL0(N+3:2*N+2)= -2*c.*alpha(1:N).*U(N+3:2*N+2) - (w(1:N).^2+alpha(1:N).^2*c^2).*U(3:2+N);
  pL0(2*N+3)= -U(2*N+3) + zeta*U(2*N+4);
  pL0(2*N+4)= -sum(U(3:2+N));
  pL0(2*N+5)= U(2*N+5);
  
 end
