function [Ups,FpnlA] = calculeseries(sys,Uo,Utj)


% Matrice tangente systeme au point de depart
dRdU = get_dRdU(sys,Uo);

% Vecteur tangent exact a la branche au point de depart
U1 = tangente(sys,dRdU,Uo);

Utj = Utj;

if (U1'*Utj) <0
  U1 = - U1;
end


% Matrice tangente de la MAN
K = [dRdU ; (get_chemin(sys).*U1(sys.idxUU))'];
invK = inv(K);


So = Uo(sys.idxUS);
  
%                 
% Premier Ordre   
%                 
Ups = U1(sys.idxUU);
Sps = L2(sys,U1) +  Q2(sys,Uo,U1) + Q2(sys,U1,Uo) ;

%                 
% Ordres suivants 
%                 

for p=2:get_ordre(sys)+1

    % Second membre equation du haut
    Fpnla = zeros(sys.neqU,1);        
    for r=1:p-1
      Fpnla = Fpnla - Q1(sys,Ups(:,r),Sps(:,p-r)) - Q(sys,Ups(:,r),Ups(:,p-r));
    end    

    % Second membre equation du bas
    Fpnlb = zeros(length(Sps(:,1)),1);    
    for r=1:p-1
      Fpnlb = Fpnlb + Q2(sys,Ups(:,r),Ups(:,p-r)) ;
    end

    if p==get_ordre(sys)+1
      break;
    end

    % Second membre conditionne
    Fpnlc = Fpnla - Q1(sys,Uo,Fpnlb) - L(sys,0*Uo,Fpnlb);

    % Equation de longueur d'arc
    Fpnlc = [Fpnlc ; 0]; 

    % Calcul terme des series
    Ups = [Ups,  invK*Fpnlc];

    Sp =  L2(sys,Ups(:,end)) + Q2(sys,Uo,Ups(:,end)) + Q2(sys,Ups(:,end),Uo) + Fpnlb;

    Sps = [Sps, Sp];


end

% On stocke la norme du residu supplementaire
FpnlA =  [Fpnla; Fpnlb];

% On reunit les variables U et S dans un U global conforme au reste de l implementation de MANLAB
Ups = [Ups ; Sps];

% On rajoute le premier terme
Ups = [Uo, Ups];



