function varargout = manlab(varargin)
% MANLAB M-file for manlab.fig
%      MANLAB, by itself, creates a new MANLAB or raises the existing
%      singleton*.
%
%      H = MANLAB returns the handle to a new MANLAB or the handle to
%      the existing singleton*.
%
%      MANLAB('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MANLAB.M with the given input arguments.
%
%      MANLAB('Property','Value',...) creates a new MANLAB or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before manlab_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to manlab_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help manlab

% Last Modified by GUIDE v2.5 04-Mar-2005 14:40:39

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @manlab_OpeningFcn, ...
                   'gui_OutputFcn',  @manlab_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before manlab is made visible.
function manlab_OpeningFcn(hObject, eventdata, handles, varargin)

global ML_first_correction_onoff;

% Choose default command line output for manlab
handles.output = hObject;

% OBJET SYSTEME
handles.sys = varargin{1};

% PARAMETRES
params.cfp = 1e-6;        % Valeur de la perturbation
params.pertsign = 0;      % Signe de la perturbation
params.endstepcorron = 0; % Correction de fin de pas de man active ou non

handles.params = params;

handles.sys = set_seuil(handles.sys, 1e-7);     % Seuil MAN initial
handles.sys = set_seuilcorr(handles.sys, 1e-8); % Seuil correction initial





% DIAGRAMME
diaginfos.uaxis = [0 1 0 1];
diaginfos.bloquervue = 0;
diaginfos.perturbation = 0;
diaginfos.drawtype = '-';
diaginfos.dispcolors = ['b','r','g','c','m','y','k','b','r','g','c','m','y','k','b'];
diaginfos.dispvars = varargin{3};
diaginfos.courbeactive = 1;

handles.diaginfos = diaginfos;
handles.diagram = DIAGRAM(diaginfos);

% POINT ORIENTE DE DEPART
handles.Uj = varargin{2};

if (length(handles.Uj(1,:)) > 1)
  errordlg('Le vecteur ML_Ustart ne semble pas avoir les bonnes dimensions. Le vecteur ML_Ustart doit etre un vecteur colone et non un vecteur ligne.','Dimensions de ML_Ustart non conformes','on');
end

if ML_first_correction_onoff==1
	handles.Uj = correction(handles.sys, get_seuilcorr(handles.sys), get_itemax(handles.sys), handles.Uj);
end
handles.Utj = tangente(handles.sys,get_dRdU(handles.sys,handles.Uj),handles.Uj );
afficher_carres(hObject, handles);

handles.Ujold =  handles.Uj;
handles.Utjold =  handles.Utj;

% CREATION D UNE BRANCHE VIDE (sinon bug)
handles.branche_courrante = BRANCHE(handles.sys, handles.Uj, handles.Utj, 0, handles.diaginfos);

% CREATION D UN TRONCON (PORTION) VIDE SINON BUG POUR LE CHARGEMENT

%   A faire ...

% AFFICHAGE SI ML_pointdisplay = 1
global ML_pointdisplay;
if ML_pointdisplay ==  1
   figure(3);
  disp(handles.sys,handles.Uj);
end

% ENREGISTREMENT DES DONNEES
guidata(hObject, handles);

% --- Outputs from this function are returned to the command line.
function mlh = manlab_OutputFcn(hObject, eventdata, handles)

mlh.hobject = hObject;
mlh.handles = handles;




function branchep_Callback(hObject, eventdata, handles)


nbtroncons = str2double(get(handles.nbtroncons,'String'));

handles.Utjold = handles.Utj;
handles.Ujold = handles.Uj;

afficher_diagramme(hObject, handles, 0);
handles.branche_courrante = BRANCHE(handles.sys, handles.Uj, handles.Utj, nbtroncons, handles.diaginfos,handles.params.endstepcorron );
[handles.Uj,handles.Utj] = point_oriente_sortie(handles.branche_courrante,get_seuil(handles.sys));
handles.branche_courrante = set_drawtype(handles.branche_courrante, handles.diaginfos.drawtype);

handles.diagram = push_branch(handles.diagram, handles.branche_courrante);
afficher_carres(hObject, handles);
handles.diaginfos.uaxis = axis;
guidata(hObject,handles);
disp('Branche calculee');

function branchem_Callback(hObject, eventdata, handles)

nbtroncons = str2double(get(handles.nbtroncons,'String'));

handles.Utjold = handles.Utj;
handles.Ujold = handles.Uj;

afficher_diagramme(hObject, handles, 0);
handles.branche_courrante = BRANCHE(handles.sys, handles.Uj, -handles.Utj, nbtroncons, handles.diaginfos,handles.params.endstepcorron);
[handles.Uj,handles.Utj] = point_oriente_sortie(handles.branche_courrante,get_seuil(handles.sys));
handles.branche_courrante = set_drawtype(handles.branche_courrante, handles.diaginfos.drawtype);

handles.diagram = push_branch(handles.diagram, handles.branche_courrante);
afficher_carres(hObject, handles);
handles.diaginfos.uaxis = axis;
guidata(hObject,handles);
disp('Branche calculee');

% --- Executes during object creation, after setting all properties.
function nbtroncons_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


function nbtroncons_Callback(hObject, eventdata, handles)
disp('Nombre de portions par branche change.');

% --- Executes on button press in recpoint.
function recpoint_Callback(hObject, eventdata, handles)

global ML_pointdisplay;

figure(2);
[handles.Uj,handles.Utj,a,b,c,handles.courbeactive] = get_point(handles.diagram);

afficher_diagramme(hObject, handles, 1);

%non, pas de correction.
%[handles.Uj] = correction(handles.sys, get_seuilcorr(handles.sys), get_itemax(handles.sys), handles.Uj);

%calcul du conditionnement
%dRdU = get_dRdU(handles.sys,handles.Uj);
%handles.Utj = tangente(handles.sys,dRdU);
%cond([dRdU;handles.Utj'])

afficher_diagramme(hObject, handles, 1);
guidata(hObject,handles);
if ML_pointdisplay==1
  figure(3);
  disp(handles.sys,handles.Uj); drawnow;
end
guidata(hObject,handles);

function cfpstr_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function cfpstr_Callback(hObject, eventdata, handles)

handles.params.cfp =  str2double(get(handles.cfpstr,'String'));

handles.sys = set_pert(handles.sys,handles.params.pertsign * handles.params.cfp);
disp('Norme de la perturbation modifiee. Retour sur la branche..');
[handles.Uj] = correction(handles.sys, get_seuilcorr(handles.sys), get_itemax(handles.sys), handles.Uj);
afficher_diagramme(hObject, handles, 1);
guidata(hObject,handles);

function seuilman_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function seuilman_Callback(hObject, eventdata, handles)
seuilman =  str2double(get(handles.seuilman,'String'));
handles.sys = set_seuil(handles.sys,seuilman);
guidata(hObject,handles);
disp('Seuil man rafraichi');
function seuilcorr_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function seuilcorr_Callback(hObject, eventdata, handles)
seuilcorr =  str2double(get(handles.seuilcorr,'String'));
handles.sys = set_seuilcorr(handles.sys,seuilcorr);
disp('Seuil correction rafraichi. Retour sur la branche avec le seuil selectionne');
[handles.Uj] = correction(handles.sys, get_seuilcorr(handles.sys), get_itemax(handles.sys), handles.Uj);
afficher_carres(hObject, handles);
afficher_diagramme(hObject, handles, 1);
guidata(hObject,handles);

function radiobutton1_Callback(hObject, eventdata, handles)
mutual_exclude([handles.radiobutton2,handles.radiobutton3]);
handles.params.pertsign = 1;
handles.sys = set_pert(handles.sys,handles.params.cfp);
handles.diaginfos.perturbation = get_pert(handles.sys);
disp('Perturbation positive selectionnee. Retour sur la branche...');
[handles.Uj] = correction(handles.sys, get_seuilcorr(handles.sys), get_itemax(handles.sys), handles.Uj);
afficher_diagramme(hObject, handles, 1);
handles.diaginfos.drawtype = '-.';
guidata(hObject,handles);

function radiobutton2_Callback(hObject, eventdata, handles)
mutual_exclude([handles.radiobutton1,handles.radiobutton3]);
handles.params.pertsign = 0;
handles.sys = set_pert(handles.sys,0);
handles.diaginfos.perturbation = get_pert(handles.sys);
disp('Perturbation nulle selectionnee. Retour sur la branche...');
[handles.Uj] = correction(handles.sys, get_seuilcorr(handles.sys), get_itemax(handles.sys), handles.Uj);
afficher_diagramme(hObject, handles, 1);
handles.diaginfos.drawtype = '-';
guidata(hObject,handles);


function radiobutton3_Callback(hObject, eventdata, handles)
mutual_exclude([handles.radiobutton1,handles.radiobutton2]);
handles.params.pertsign = -1;
handles.sys = set_pert(handles.sys,-handles.params.cfp);
handles.diaginfos.perturbation = get_pert(handles.sys);
disp('Perturbation negative selectionnee. Retour sur la branche...');
[handles.Uj] = correction(handles.sys, get_seuilcorr(handles.sys), get_itemax(handles.sys), handles.Uj);
afficher_diagramme(hObject, handles, 1);
handles.diaginfos.drawtype = '-.';
guidata(hObject,handles);

function mutual_exclude(off)
set(off,'Value',0)


function load_Callback(hObject, eventdata, handles)

[file,path] = uigetfile;
loadeddatas = load('-mat',[path file],'diagram') ;
handles.diagram = loadeddatas.diagram;
afficher_diagramme(hObject, handles, 1);

guidata(hObject,handles);


function save_Callback(hObject, eventdata, handles)

[file,path] = uiputfile;
diagram = handles.diagram;
save([path file], 'diagram') ;

guidata(hObject,handles);


function voirpoint_Callback(hObject, eventdata, handles)

global ML_pointdisplay;

figure(2);
[handles.Uj,handles.Utj,a,b,c,handles.courbeactive] = get_point(handles.diagram);

afficher_diagramme(hObject, handles, 1);

figure(3);
disp(handles.sys,handles.Uj); drawnow;

guidata(hObject,handles);


function effacertroncon_Callback(hObject, eventdata, handles)
figure(2);
handles.diagram = delete_troncon(handles.diagram);

afficher_diagramme(hObject, handles, 1);

guidata(hObject,handles);


function effacerbranche_Callback(hObject, eventdata, handles)
figure(2);
handles.diagram = delete_branche(handles.diagram);

afficher_diagramme(hObject, handles, 1);

guidata(hObject,handles);

function bloquervuecheck_Callback(hObject, eventdata, handles)

if (get(hObject,'Value') == get(hObject,'Max'))
  disp('Vue bloquee');
  handles.diaginfos.bloquervue = 1;
  figure(2);  handles.diaginfos.uaxis = axis ;
else
  disp('Vue non bloquee');
  handles.diaginfos.bloquervue = 0;
  figure(2);  axis auto ; handles.diaginfos.uaxis = axis ;  
end

guidata(hObject,handles);



function importeruj_Callback(hObject, eventdata, handles)

global ML_Uj;


if length(ML_Uj)~=get_ninc(handles.sys)
  disp('ERREUR : Variable ML_Uj non definie ou de taille incompatible.');
else
disp('Variable environnement ML_Uj importee.');

disp('Retour sur la branche...');

[handles.Uj] = correction(handles.sys, get_seuilcorr(handles.sys), get_itemax(handles.sys), ML_Uj);
handles.Utj = tangente(handles.sys,get_dRdU(handles.sys,handles.Uj),handles.Uj);
afficher_diagramme(hObject, handles,1);

guidata(hObject,handles);
end



function afficher_diagramme(hObject, handles, tracer_carres)


figure(2);  handles.diaginfos.uaxis = axis ;clf; disp(handles.diagram);

if handles.diaginfos.bloquervue == 1
  axis (handles.diaginfos.uaxis);
else
  axis auto;
end

guidata(hObject,handles);
if tracer_carres ==1
  afficher_carres(hObject, handles);
end

function afficher_carres(hObject, handles)
figure(2);
% Pour chaque courbes
hold on ;
%fxhandle = get_fxhandle(handles.sys);
%fyhandle = get_fyhandle(handles.sys);
%x = feval(fxhandle,handles.sys,handles.Uj(idxX));
%y = feval(fyhandle,handles.sys,handles.Uj(idxY));
%petits carres
for i=1:length(handles.diaginfos.dispvars(:,1))
idxX = handles.diaginfos.dispvars(i,1);
idxY = handles.diaginfos.dispvars(i,2);
plot(handles.Uj(idxX),handles.Uj(idxY),'sk');
end
% petites fleches
s = axis;

lxe = abs(s(2)-s(1));
lye = abs(s(4)-s(3));


for i=1:length(handles.diaginfos.dispvars(:,1))
 idxX = handles.diaginfos.dispvars(i,1);
 idxY = handles.diaginfos.dispvars(i,2);
 utx = handles.Utj(idxX);
 uty = handles.Utj(idxY);
 lt = sqrt((utx/lxe)^2+(uty/lye)^2)*15;
 utx = utx/lt;
 uty = uty/lt;

 plot([handles.Uj(idxX), handles.Uj(idxX)+utx],[handles.Uj(idxY), handles.Uj(idxY)+uty],'k');
%quiver(handles.Uj(idxX),handles.Uj(idxY),utx*l,uty*l,'k');
end
hold off


function Saut_Callback(hObject, eventdata, handles )

disp('Selectionnez le point de d arrivee.');
figure(2); [x,y] = ginput(1);


Uj=handles.Uj;

handles.Utj = tangente(handles.sys,get_dRdU(handles.sys,handles.Uj),handles.Uj);

Utj = handles.Utj;

k = handles.diaginfos.courbeactive;


idx = handles.diaginfos.dispvars(k,1);
idy = handles.diaginfos.dispvars(k,2);

% Normalisation de la tangente VISIBLE !
Utj = Utj/sqrt((Utj(idx)^2+Utj(idy)^2));

xdep = Uj(idx);
ydep = Uj(idy);


% On calcule la longueur du saut
longueur = sqrt((x-xdep)^2+(y-ydep)^2);

% On calcule le produit scalaire pour determiner le sens
scal = (x-xdep)*Utj(idx) + (y-ydep)*Utj(idy);

if scal < 0
  Utj = -Utj;
end


% On effectue le saut
Uj = Uj + longueur * Utj;

disp('Retour sur la branche...');
% On effectue la correction

[handles.Uj] = correction(handles.sys, get_seuilcorr(handles.sys), get_itemax(handles.sys), Uj);
handles.Utj = tangente(handles.sys,get_dRdU(handles.sys,handles.Uj),handles.Uj);
afficher_diagramme(hObject, handles,1);

guidata(hObject,handles);


function variables_Callback(hObject, eventdata, handles)


dispvars = handles.diaginfos.dispvars;

nbmaxd = 8;
prompt = {'x1,y1','x2,y2','x3,y3','x4,y4','x5,y5','x6,y6','x7,y7','x8,y8'};
def =    {'0,0' ,'0,0' ,'0,0' ,'0,0' ,'0,0' ,'0,0' ,'0,0' ,'0,0' ,'0,0'};

for i=1:length(dispvars(:,1));
  def{i} = [num2str(dispvars(i,1)) ',' num2str(dispvars(i,2))];
end

rep = inputdlg(prompt,'Titre',1,def);

dispvars = [];
for i=1:nbmaxd
  a = sscanf(rep{i},'%i,%i');
  if (a(1) <=0)
    break;
  end
  
  dispvars(i,1) = a(1);
  dispvars(i,2) = a(2);
end

handles.diaginfos.dispvars = dispvars;


handles.diagram = evalue(handles.diagram, get_nbptstroncon(handles.sys), ...
       handles.diaginfos);

afficher_diagramme(hObject, handles,1);
guidata(hObject,handles);


function exporteruj_Callback(hObject, eventdata, handles)

global ML_Uj;
global ML_Utj;

ML_Uj = handles.Uj;
ML_Utj = handles.Utj;

disp(['Variable globale ML_Uj exportee. Les coordonnees du point courant sont maintenant dans la variable globale ML_Uj']);


function effacerdiagramme_Callback(hObject, eventdata, handles)

figure(2);
handles.diagram = delete_allbranches(handles.diagram);

afficher_diagramme(hObject, handles, 1);

guidata(hObject,handles);


function effacerderbranche_Callback(hObject, eventdata, handles)


figure(2);
handles.diagram = delete_lastbranche(handles.diagram);

handles.Utj = handles.Utjold;
handles.Uj = handles.Ujold;

afficher_diagramme(hObject, handles, 1);

guidata(hObject,handles);
disp('Derniere branche calcule effacee.');

function visualisertroncon_Callback(hObject, eventdata, handles)
disp('Selectionnez la portion a visualiser');
figure(2);

[idxbranch,idxtroncon,Afound, kfound] = get_indexes(handles.diagram);
troncon = get_troncon(handles.diagram, idxbranch, idxtroncon);

figure(4);
disp_global(handles.sys,get_Us(troncon,get_seuilman(troncon),get_nbptstroncon(handles.sys)));

function visualiserbranche_Callback(hObject, eventdata, handles)
disp('Selectionnez la branche a visualiser');
figure(2);
 [idxbranch,idxtroncon,Afound, kfound] = get_indexes(handles.diagram);
branche = get_branche(handles.diagram, idxbranch);

figure(4);
disp_global(handles.sys,get_Us(branche,get_nbptstroncon(handles.sys)));

function visualiserdiagramme_Callback(hObject, eventdata, handles)
disp('Visualisation du diagramme"');

figure(4);

branches = get_branches(handles.diagram);

hold off;

for i = 1:length(branches)
disp([num2str(i) '/' num2str(length(branches))]);
  disp_global(handles.sys,get_Us(branches{i},get_nbptstroncon(handles.sys)));
hold on;
end  
hold off;


function exportertroncon_Callback(hObject, eventdata, handles)
figure(2);
disp('Selectionnez la portion a exporter');
[idxbranch,idxtroncon,Afound, kfound] = get_indexes(handles.diagram);
troncon = get_troncon(handles.diagram, idxbranch, idxtroncon);

global ML_Ut;
global ML_Ups;
ML_Ut = get_Us(troncon,get_seuilman(troncon),get_nbptstroncon(handles.sys));
ML_Ups = get_Ups(troncon);
disp('Les donnees de la portion se trouvent dans la variable ML_Ut');
disp('Les termes de serie de la portion se trouvent dans la variable ML_Ups');

function exporterbranche_Callback(hObject, eventdata, handles)
disp('Selectionnez la branche a exporter');
figure(2);
 [idxbranch,idxtroncon,Afound, kfound] = get_indexes(handles.diagram);
branche = get_branche(handles.diagram, idxbranch);

global ML_Ub;
ML_Ub = get_Us(branche,get_nbptstroncon(handles.sys));
disp('Les donnees de la portion se trouvent dans la variable ML_Ub');

function exporterdiagramme_Callback(hObject, eventdata, handles)

global ML_Ud;
ML_Ud = get_Us(handles.diagram,get_nbptstroncon(handles.sys));

disp('Les donnees du diagramme se trouvent dans la variable ML_Ud');


function corractive_Callback(hObject, eventdata, handles)

if (get(hObject,'Value') == get(hObject,'Max'))
  disp('Correction de fin de portion (troncon) activee');
  handles.params.endstepcorron = 1;
else
  disp('Correction de fin de portion (troncon) desactivee');
  handles.params.endstepcorron = 0;
end

guidata(hObject,handles);
