      SUBROUTINE EVE_CORRECTIONS(NOMFICH,CRITER,MAXITER,
     *                           C0,U0,SIG0,Ftra)
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
COMM %                                                                %
COMM %   Iterations de correction de newton                           %
COMM %                                                                %
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
      INCLUDE "tableau.f" 
      DOUBLE PRECISION DC0,CRITER
      INTEGER MAXITER
      CHARACTER*20 NOMFICH 
      LOGICAL TOURNE
      
      OPEN(UNIT=5,FILE=NOMFICH,STATUS='OLD',ACCESS='SEQUENTIAL')  
COMM ..................................................................
COMM //////       Lecture des donnes dans le fichier cl       //////
COMM ..................................................................
      CALL DONNEE(COOR,MAIL,EMAI,EPAI,LIAI,DFOR,DREL,ICO,MAXNOE,MAXELE)
      CLOSE(5)
COMM ..................................................................      
COMM ......../////  reprise des valeurs entires dans ICO  ///////....... 
COMM ..................................................................     
      KTYP =ICO(1)
      NCPN =ICO(2)
      NDPN =ICO(3)
      NNPE =ICO(4)
      NSPG =ICO(5)            
      NNOE =ICO(6)
      NDL  =ICO(7)
      NMAI =ICO(8)
      NVMA =ICO(10)
      NLIAI=ICO(11)
      NVF1 =ICO(13)
      IF(KTYP.EQ.1.OR.KTYP.EQ.2.OR.KTYP.EQ.3) THEN ! Elasticite 2D
        NTPG=4
      ELSE IF(KTYP.EQ.4) THEN                      ! Elasticite 3D
        NTPG=9 
      ELSE IF(KTYP.EQ.5) THEN                      ! Coques 
        NTPG=2       
      ELSE
       STOP ' Pb KTYP ANMCA2 '
      ENDIF                        
COMM ..................................................................  
COMM .....//// Profil de K, nombre de termes de K et de S ////......
COMM  ..................................................................  
      CALL PROFBI(IDIA,MAIL,NDL,NMAI,NRIG,NNPE,NDPN,KTYP)
      ICO(26)=NRIG
      CALL LONSIG(MAIL,NMAI,NNPE,NSPG,NSIG,NEPS,KTYP)
      ICO(27)=NSIG
      NTET=(NSIG/NSPG)*NTPG  
COMM ..................................................................  
COMM ..........//// vecteur des forces exterieures  ////......
COMM  ..................................................................                               
      CALL CAFORC(DFOR,F,ICO)
      CALL DACTUA(Ftra,F,NDL,C0)
COMM ..................................................................  
COMM ..........//// calcul du residu  ////......
COMM  ..................................................................          
      ITER=0
      TOURNE=.TRUE.
      CALL RESIDU(U0,COOR,MAIL,EMAI,EPAI,SIG0,RES,Ftra,
     *            NMAI,NDL,NCPN,NDPN,NNPE,NVMA,KTYP)
      CALL CALIMP(LIAI,RES,NLIAI,NDPN)
C
      CALL ECPAS(U0,RES,ITER,ICO)
      CALL CRITCO(RES,Ftra,CRITER,NNOE,NDL,ITER,TOURNE)

COMM  
COMM ........../////   ITERATION DE NEWTON-RAPHSON  /////........
COMM 
      DO WHILE(TOURNE.AND.ITER.LT.MAXITER)
      ITER=ITER+1
C   
      CALL RIGTAN(RIG,IDIA,COOR,MAIL,EMAI,EPAI,U0,SIG0,
     *            NMAI,NDL,NCPN,NDPN,NNPE,NSPG,NVMA,KTYP)
      CALL CALIRI(RIG,IDIA,LIAI,NLIAI,NDPN,NDL)
      CALL DECCHO(RIG,IDIA,NDL,0)
C
      CALL CALIMP(LIAI,RES,NLIAI,NDPN)
      CALL RESCHO(RIG,RES,IDIA,NDL)
C
      CALL SHIFTD(F,Utra,NDL)
      CALL CALIMP(LIAI,Utra,NLIAI,NDPN)
      CALL RESCHO(RIG,Utra,IDIA,NDL)      
      
      DC0=-PROSCA(Utra,RES,NDL)/(1.D0+PROSCA(Utra,Utra,NDL))
C
      C0=C0+DC0
      CALL DSOMME(U0,RES,NDL)
      CALL DACTUA(U0,Utra,NDL,DC0)
      CALL DINCRE(F,Ftra,NDL,C0)
C 
      CALL RESIDU(U0,COOR,MAIL,EMAI,EPAI,SIG0,RES,Ftra,
     *            NMAI,NDL,NCPN,NDPN,NNPE,NVMA,KTYP)
      CALL CALIMP(LIAI,RES,NLIAI,NDPN)
C      
      CALL ECPAS(U0,RES,ITER,ICO)
      CALL CRITCO(RES,Ftra,CRITER,NNOE,NDL,ITER,TOURNE)
C
      ENDDO
          
      END         
      
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
COMM %                                                                %
COMM %   The gateway routine                                          %
COMM %                                                                %
COMM %   [Ci,Ui,SIGi]=EVE_CORRECTIONS('nom fichier.cle',              %
COMM %                               CRITER,MAXITER,C0,U0,SIG0,P)     %                                                             %
COMM %                                                                %
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%                 
      
      subroutine mexFunction(nlhs, plhs, nrhs, prhs)
C--------------------------------------------------------------
      INCLUDE "tableau.f"
      
      integer plhs(*), prhs(*)
      integer nlhs, nrhs
      
      integer  status, strlen
            
      integer mU, nU, sizeU, mSIG, nSIG, sizeSIG
      
      integer mxGetM, mxGetN, mxIsNumeric, mxIsChar
      integer mxCreateString, mxGetString
      integer mxCreateDoubleMatrix  
          
      integer criter_pr,maxiter_pr,C0_pr,U0_pr,SIG0_pr,P_pr
      integer Ci_pr,Ui_pr,SIGi_pr
      
c-----Declaration des variables Fortran-----
      character*20 NOMFICH
      real*8  CRITER,REAL_MAXITER
      
      
C     Check for proper number of arguments. 
      if (nrhs .ne. 7) then
         call mexErrMsgTxt('7 arguments demandes en entre')
      elseif (nlhs .ne. 3) then
         call mexErrMsgTxt('3 argument demandes en sortie') 
	 
C     The first input  must be a string.
      elseif(mxIsChar(prhs(1)) .ne. 1) then
         call mexErrMsgTxt('Input must be a string.')

C     The input must be a row vector.
      elseif (mxGetM(prhs(1)) .ne. 1) then
         call mexErrMsgTxt('Input must be a row vector.')
      endif
    
C     Get the length of the input string.
      strlen = mxGetM(prhs(1))*mxGetN(prhs(1))

C     Get the string contents (dereference the input integer).
      status = mxGetString(prhs(1), NOMFICH, 20)

C     Check if mxGetString is successful.
      if (status .ne. 0) then 
         call mexErrMsgTxt('Nom de fichier trop long (20 max)')
      endif
C-----traitement de CRITER et de MAXITER  
      criter_pr = mxGetPr(prhs(2)) 
      call mxCopyPtrToReal8(criter_pr, CRITER, 1)    
         
      maxiter_pr = mxGetPr(prhs(3))  
      call mxCopyPtrToReal8(maxiter_pr, REAL_MAXITER, 1)
      MAXITER=INT(REAL_MAXITER)      
          
C-----traitement des arguments suivants
C     taille de U0 et SIG0

      mU = mxGetM(prhs(5))
      nU = mxGetN(prhs(5))
      sizeU = mU*nU           
      mSIG = mxGetM(prhs(6))
      nSIG = mxGetN(prhs(6))
      sizeSIG = mSIG*nSIG          
      
      
C     Create matrix for the return argument.
      plhs(1) = mxCreateDoubleMatrix(1   , 1   , 0)
      plhs(2) = mxCreateDoubleMatrix(mU  , nU  , 0)      
      plhs(3) = mxCreateDoubleMatrix(mSIG, nSIG, 0)      
   

C-----pointeur pour les arguments d'entre  puis de sortie  
      C0_pr     = mxGetPr(prhs(4))      
      U0_pr     = mxGetPr(prhs(5))
      SIG0_pr   = mxGetPr(prhs(6)) 
      P_pr      = mxGetPr(prhs(7))
      
      Ci_pr     = mxGetPr(plhs(1))      
      Ui_pr     = mxGetPr(plhs(2))
      SIGi_pr   = mxGetPr(plhs(3))   
      
C     Load the data into Fortran arrays.
      call mxCopyPtrToReal8(C0_pr, C0, 1)
      call mxCopyPtrToReal8(U0_pr, U0, sizeU)
      call mxCopyPtrToReal8(SIG0_pr, SIG0, sizeSIG)     
      call mxCopyPtrToReal8(P_pr, Ftra, sizeU)             
      
C     Call the computational subroutine.
      call EVE_CORRECTIONS(NOMFICH,CRITER,MAXITER,
     *                       C0,U0,SIG0,Ftra)
                 
C     Load the output into a MATLAB array.
      call mxCopyReal8ToPtr(C0, Ci_pr, 1)
      call mxCopyReal8ToPtr(U0, Ui_pr, sizeU)      
      call mxCopyReal8ToPtr(SIG0, SIGi_pr, sizeSIG)                 
      return
      end
